
// You can change these if you like
const CLASS_ID = Components.ID("26caa3d0-139e-4d18-acf4-3b759886880c");
const CLASS_NAME = "Ask Search";
const CONTRACT_ID = "@ask/AskSearch;1";


var DNS = null;
var isListenerSet = null;
var ffwindow = null;

function get_DNSService() 
{
        dump("\n\nget_DNSService function called\n\n");
        if( !DNS ) 
        {
                DNS = Components.classes['@mozilla.org/network/dns-service;1'].getService(Components.interfaces.nsIDNSService);
        }
        dump("\n\nfunction:get_DNSService Completed " + DNS + "\n\n");
        return DNS;
}

var listener =
{
  	QueryInterface : function(aIID)
  	/* {00000000-0000-0000-c000-000000000046} */
  	{
      		dump("\n\nDNSlistener: QueryInterface(" + aIID + ")\n\n");
 	     	if (aIID.equals(Components.interfaces.nsIDNSListener) ||
          	    aIID.equals(Components.interfaces.nsISupports) ) 
          	{
          		dump("\n\nDNSlistener: QueryInterface : Successful\n\n");
          		return this;
      		}
      		throw Components.results.NS_NOINTERFACE;
      		Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
      		return null;
  	},
  	
  	onLookupComplete: function( aRequest, aRecord, aStatus )
  	{
    		dump("\n\nDNSistener: onLookupComplete(" + aRequest + ", " + aRecord + ", " + aStatus +")\n\n");
    		if( this._thumb && aStatus ) 
    		{
      			var sIp = aRecord.getNextAddrAsString();
      			if( sIp ) 
      			{
        			dump("\n\nDNSlistener: onLookupComplete() sIp = " + sIp +"\n\n" );
      			}
    		}	
  	}
}


function sResolve(domain) 
{
	dump("\n\nsResolve(" + domain + ")\n\n");
        
        var dns = get_DNSService();
        if( dns ) 
        {
                dump("\n\nDNS Service : " + dns + "\n\n");
                var ip = null;
                if( domain ) 
                {
                	dump("\n\nDomain : " + domain + "\n\n");
                	try
                	{
        			ip = dns.resolve( domain, false).getNextAddrAsString();
                        }
                        catch( ex )
                        {
        			dump("\n\nsResolve() Exception : " + domain + ":"+ex +"\n\n");
        			return false;
                        }
                        if( ip ) 
                        {
                                dump("\n\nsResolve() Resolving '" + domain + "' as '" + ip +"\n\n");
                        }
                }
        }
        dump("\n\nsResolve() return\n\n");
        return true;
}

function aResolve(domain) 
{
        dump("\n\naResolve(" + domain + ")\n\n");
        var dns = get_DNSService();
        if( dns ) 
        {
                var ip = null;
                if( domain ) 
                {
                        try 
                        {
                                ip = dns.asyncResolve( domain, false, listener, null );
                        }
                        catch( ex ) 
                        {
                                dump("\n\naResolve: Exception : " + href +"\n\n");
                        }
                }
        }
        dump("\n\naResolve() return\n\n");
        return false;
}


var HomePageForeverListener =
{
	QueryInterface: function(aIID)
      	{
        	if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
          	    aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          	    aIID.equals(Components.interfaces.nsISupports ))
              	{
              		return this;
              	}
          	throw Components.results.NS_NOINTERFACE;
      	},


	onStateChange:function(aProgress, aRequest, aFlag, aStatus)
      	{
        	try
			{
				var path = Components.classes["@mozilla.org/file/directory_service;1"].
  				getService( Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile).path + "\\extensions\\{E9A1DEE0-C623-4439-8932-001E7D17607D}";

				var profdFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				profdFile.initWithPath(path);
				
				if( profdFile.exists() ) 
				{   
					if (profdFile.isDirectory())
					{
						dump("\n\nexit\n\n");
						return 0;
					}
				}
			}
			catch(e)
			{
				dump("\n\nException : " +e +"\n\n");
			}
			
        	if(aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT)
        	{
        		aRequest.QueryInterface(Components.interfaces.nsIHttpChannel);
              		var responseCode = -1;
              		try
              		{
                		responseCode = aRequest.responseStatus;
              		}
              		catch( ex)
              		{	
      				dump("\n\nonStateChange" + aRequest.URI.host + " exception :" + ex+"\n\n" );
              		}
              		if(responseCode < 0 && !sResolve(aRequest.URI.host))
              		{
              			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
          			var url = prefs.getCharPref("keyword.URL");
                  		dump("\n\nkeyword.url : " + url + "\n\n");
                  		var query = aRequest.URI.host;
			        url = url + query;
          			dump("\n\nDNS error URL : " + url+"\n\n");
          			ffwindow.content.document.location.href=url;
         		}
		}

      	},

       	onLocationChange: function(aProgress, aRequest, aURI)
        {
        	return 0;
        },

      	onLocationChange: function() 
      	{
              	return 0;
        },
      	onProgressChange: function() 
      	{
                return 0; 
        },
      	onStatusChange: function() 
      	{
        	return 0;
        },
      	onSecurityChange: function()
      	{
                return 0; 
        },
      	onLinkIconAvailable: function() 
      	{
                return 0; 
        }

}

function eventHandler(window) 
{
  	this.window = window;
  	ffwindow = window;
}

eventHandler.prototype = 
{
	
	onLoad:function() 
	{
    		var browser = this.window.document.getElementById("content");
		if (browser && isListenerSet == null)
		{
      			browser.addProgressListener(HomePageForeverListener);
      			isListenerSet =1;
      			dump("\n\nListener is added successfully\n\n");
      		}
      		else if(isListenerSet ==1)
      		{
      			dump("\n\nListener already set\n\n");
      		}
  	},
  
  	onClose:function() 
  	{
  		var browser = this.window.document.getElementById("content");
    		if (browser && isListenerSet == 1)
    		{
     			browser.removeProgressListener(HomePageForeverListener);
     			isListenerSet = null;
     			dump("\n\nListener is removed successfully\n\n");
      		}
    		window = null;
  	},
	
	window: null,
}

var askObserverObj = 
{
	pObserverServicePtr: null,

	observe: function(aSubject, aTopic, aData)
	{
		dump("\n\nObserve: topic = "+ aTopic+"\n\n");
		if (aTopic == "xpcom-startup")
		{
			this.pObserverServicePtr =  Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
			this.pObserverServicePtr.addObserver(this, "domwindowopened", false);
			dump("\n\nAdded Observer : domwindowopened\n\n");
		}
		
		if (aTopic == "domwindowopened") 
		{
		      	var window = aSubject.QueryInterface(Components.interfaces.nsIDOMWindow);
		      	var event_handler = new eventHandler(window);
      		      	try
      		      	{
      		      		window.addEventListener("load", event_handler.onLoad, false);
      		      	}
      		      	catch(e)
      		      	{
      		      		dump("\n\nException in AskObserver - " +e+"\n\n");	
      		      	}
      		}
      		//var webListener = Components.classes["@ask.com/search;1"].getService(Components.interfaces.nsISupports);	
		dump("\n\nObserver: Successful\n\n");
	},

	QueryInterface: function(aIID)
	{
  		if (aIID.equals(Components.interfaces.nsIObserver) ||
      		    aIID.equals(Components.interfaces.nsISupports)) 
      		{
    			dump("\n\nAskObserverObject: QueryInterface successful\n\n");
    			return this;                               			
  		}
		throw Components.results.NS_ERROR_NO_INTERFACE;
	},
}

var AskSearchFactory = 
{
  	createInstance: function (aOuter, aIID)
  	{
		if (aOuter != null) 
		{
			dump("\n\nError while creating instance in AskObserverFactory\n\n");
			throw Components.results.NS_ERROR_NO_AGGREGATION;
		}
		if (aIID.equals(Components.interfaces.nsIObserver)||
		    aIID.equals(Components.interfaces.nsISupports)) 
		{
			dump("\n\nAskObserverFactory Successful "+ aIID+"\n\n");
			return askObserverObj.QueryInterface(aIID);
		}

		dump("\n\nAskObserverFactory Failed - Invalid argument "+ aIID+"\n\n");
		throw Components.results.NS_ERROR_INVALID_ARG;
	}
};

// Module
var AskSearchModule = 
{
	registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
	{
  		aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
  		aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);
  
  		var catman = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
  		catman.addCategoryEntry("xpcom-startup", "Ask Search", "@ask/AskSearch;1", true, true);
  		catman.addCategoryEntry("xpcom-shutdown", "Ask Search", "@ask/AskSearch;1", true, true);
		dump("\n\nAskSearchModule: Registration Successful\n\n");
	},

	unregisterSelf: function(aCompMgr, aLocation, aType)
	{
  		aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
  		aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);        
		
		var catman = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
		catman.deleteCategoryEntry("xpcom-shutdown", "Ask Observer Object", true);
    		catman.deleteCategoryEntry("xpcom-startup", "Ask Observer Object", true);
    
		dump("\n\nAskSearchModule: UnRegistration Successful\n\n");
	
  	},
  
  	getClassObject: function(aCompMgr, aCID, aIID)
  	{
    		if (!aIID.equals(Components.interfaces.nsIFactory))
    		{
			dump("\n\nAskSearchModule: GetClassObject Failed due to aIID not equal to nsIFactory\n\n");
      			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		}
    		if (aCID.equals(CLASS_ID))
    		{
      			return AskSearchFactory;
      		}

		dump("\n\nAskSearchModule: GetClassObject Failed due to Contract ID mismatch\n\n");
    		throw Components.results.NS_ERROR_NO_INTERFACE;
  	},

	canUnload: function(aCompMgr) 
	{
		dump("\n\nAskSearchModule: CanUnload method returned true\n\n");
		return true; 
	}
	
};

//module initialization
function NSGetModule(aCompMgr, aFileSpec) 
{
	dump("\n\nAskSearch Module returned back when NSGetModule is called during initialization\n\n");
	return AskSearchModule; 
}




